/*
 * (C) Copyright Keith Visco 1999  All rights reserved.
 *
 * The contents of this file are released under an Open Source 
 * Definition (OSD) compliant license; you may not use this file 
 * execpt in compliance with the license. Please see license.txt, 
 * distributed with this file. You may also obtain a copy of the
 * license at http://www.clc-marketing.com/xslp/license.txt
 *
 * The program is provided "as is" without any warranty express or
 * implied, including the warranty of non-infringement and the implied
 * warranties of merchantibility and fitness for a particular purpose.
 * The Copyright owner will not be liable for any damages suffered by
 * you as a result of using the Program. In no event will the Copyright
 * owner be liable for any special, indirect or consequential damages or
 * lost profits even if the Copyright owner has been advised of the
 * possibility of their occurrence.
 *
 */
package com.kvisco.xpath;

import org.w3c.dom.*;

/**
 * Simple interface for XSL Expressions
 * @author <a href="mailto:kvisco@ziplink.net">Keith Visco</a>
**/
public interface Expr {

    public static short PRIMARY    = 0;
    public static short BOOLEAN    = 1;
    public static short NODE_SET   = 2;
    public static short NUMBER     = 3;
    public static short STRING     = 4;
    
      //------------------/
     //- Public Methods -/
    //------------------/
    
    /**
     * Returns the type of Expr this Expr represents
     * @return the type of Expr this Expr represents
    **/
    public short getExprType();
    
    /**
     * Evaluates this Expr using the given ExprContext
     * @param context the current context Node
     * @param contextInfo all context information needed for
     * evaluating this XPath expr
     * @return the ExprResult
    **/
    public ExprResult evaluate(Node context, ExprContext contextInfo)
        throws InvalidExprException;
    
    public String toString();
    
} //-- Expr